cls
#Powershell-Script by Thomas Windscheif
#http://microlinc.homeip.net
#permission propagation with reading existing permissions on topfolder inbox MsX2k10
#Ver 1.1 2013/07/10
#bugfixed - now detectcs more than one Accessright
# reads the permissions on topfolder 
write-host "permission propagation with reading existing permissions on topfolder by microlinc / author Thomas Windscheif" -Foregroundcolor Green
#Die unteren Felder knnen auch vordefiniert werden
#Lschen der Berechtigungen oder hinzufgen? ([h]inzufgen / [l]schen)
$what=""
#Name des Benutzers dessen Postfach angepasst werden soll
$usera=""
#inbox name depends on the used language, (predefined: Posteingang (german))
$inbox_lang="Posteingang"

if ($a) {
clear-variable a
}
if ($b) {
clear-variable b
}

#declare as arrays
$a=@()
$b=@()

if (!$what) {
$what=read-host "`n `nSollen die Berechtigungen hinzugefgt werden, oder gelscht werden?  ([h]inzufgen / [l]schen)"
}

if (!$usera) {
$usera=read-host "`n`nGeben Sie den Benutzernamen des zu verndernden Postfachs an:"
} 
get-mailboxfolderpermission "${usera}:\Posteingang" | select-object $_.User | foreach-object {
if (("$($_.User)" -ne "Standard") -and ("$($_.User)" -ne "Anonym")) {$a+=,@("$($_.User)",$($_.Accessrights))}
}
write-host "Gefundene Benutzerrechte im Top-Folder inbox/Posteingang:" -Foregroundcolor Green
write-Host "User:`t`tUserrecht:" -Foregroundcolor Green
get-mailboxfolderstatistics "$usera" -folderscope inbox | select FolderPath | % {$b += $_.FolderPath}
#passt die Ausgabe von get-mailboxfolderstatistics fr die weitere Bearbeitung an

$b=$b -replace "/","\"
$a | % {
Write-Host "$($_[0])`t$($_[1])"

#"User: $($_[0]) Userrecht: $($_[1])"
} 
Write-Host "`n`n"
if ($what -eq "l") {
$whatword="lschen"
}
if ($what -eq "h") {
$whatword="setzen"
}

$a | % {

$userb="$($_[0])"
$right=$($_[1])

Write-Host "`nRechte ($($_[1])) fr den Benutzer $($_[0]) $whatword`n" -ForeGroundColor DarkYellow
$b | %{ 
Write-Host "Bearbeite $_ fr $userb" -ForeGroundColor Green
if ("$_" -ne "\$inbox_lang")  {
if ($what -eq "h") { 
#propagates permissions on subfolders of inbox
#$end = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown"); exit
if (add-mailboxfolderpermission "${usera}:\$inbox_lang$($_)" -user "$userb" -AccessRight ($right)) {
Write-Host "${usera}:\$inbox_lang$($_)" -Foregroundcolor Green
}
}
if ($what -eq "l") {
#removes permissions on subfolders of inbox
remove-mailboxfolderpermission "${usera}:\$inbox_lang$($_)" -user "$userb" -confirm:$false
}
}
}

#Write-Host "$($_[0])`t$($_[1])"
#"User: $($_[0]) Userrecht: $($_[1])"
}

if ($what -eq "l") {
write-host "`n`nDie obersten Berechtigungen auf Posteingang entfernen Sie bitte manuell!`nHierzu knnen Sie das cmdlet remove-mailboxfolderpermission verwenden" -Foregroundcolor Red
}
write-host "`nDie Ausfhrung des Skripts ist nun abgeschlossen!" -Foregroundcolor Green
$end = $host.UI.RawUI.ReadKey("NoEcho,IncludeKeyDown"); exit